#ifndef GLOBAL_H
#define GLOBAL_H

//---------------------------------------------------------

// uncomment this macro will produce loader for MicroSD version
#define MICROSD

// uncomment this line will use slow write functions
#define SAVE_SLOW_WRITE_MODE
//----------------------------------------------------------


inline void clearmem(u32 dest, u32 size);

inline void copy(void *src, void *dst, int size);

inline void FastMemSet(u32 dest, u32 val, u32 size);

// copy header
#define  ComputedHeaderCRC (*(u16 *)(0x027ff808))
#define  ComputedSecureCRC (*(u16 *)(0x027ff80a))


// second place

#define  ComputedHeaderCRC_2 (*(u16 *)(0x027ffc08))
#define  ComputedSecureCRC_2 (*(u16 *)(0x027ffc0a))

#define ROM_START_ADDRESS (0x027FFDF0)

#define SUPPORT_EXT_TYPES 3
extern char *fileExts[];
bool FileExtFilter(char* fn, char *ext, u32 f_type);


void die();

extern char  curPath[256]; 
int miniSaveMenu();
void PreTrans(unsigned long absAddr);
void PostTrans();

void bmemcpy(u8  *dst, u8 *src, u32 size);
void FileSystemInit();

// True HZK loaded. Chinese string resources loaded.
// Use 8.3 short names.
extern bool chnSupport;

#define IDLE_TIME_COUNTER 3000

//-----------------------------------------------------------------
//0x0200 0000 - 0x020C 0000-1		font [512KB+256KB]
//0x020C 0000 -	0x0210 0000-1		menuitems[256KB]
//0x0210 0000 - 0x0210 1000-1		ank table[4K]
//0x0210 1000 - 0x0214 1000-1		Loc2Uni table[256KB]

#define FONT_BASE_ADDR (0x02000000)
// unicode file names are stored here
#define MenuItemsUni	(u16*)(0x020C0000)
// ank table
#define ANK_TABLE_ADDR (0x02100000)
// l2u table
#define L2U_TABLE_ADDR (0x02101000)

// UNI font
#define UNI_FONT_ADDR (0x02200000)


#define BIT0 (1<<0)
#define BIT1 (1<<1)
#define BIT2 (1<<2)
#define BIT3 (1<<3)
#define BIT4 (1<<4)
#define BIT5 (1<<5)
#define BIT6 (1<<6)
#define BIT7 (1<<7)
#define BIT8 (1<<8)
#define BIT9 (1<<9)
#define BIT10 (1<<10)
#define BIT11 (1<<11)
#define BIT12 (1<<12)
#define BIT13 (1<<13)
#define BIT14 (1<<14)
#define BIT15 (1<<15)

//#define VRAMBuf ((u16*)(0x06000000))
#define VRAMBuf ((u16*)NDSDrawCanvas)

#endif // GLOBAL_H

