#include <nds.h>

#include "common.h"
#include "sdbasic.h"
#include "sddev.h"
#include "sdrw.h"
#include "crc.h"

//////////////////////////////////
extern unsigned int  DirStartCluster;
unsigned long  DirStartCluster32;

void sdmFastReadData512(u16 *dst);
void sdmFastReadData512C(u16 *dst);



void PreTrans(unsigned long absAddr)
{

	// multi sector reading ...
	unsigned char argument[4];
	

	u32 blockaddr;
	blockaddr = absAddr;


	// Pack the address 
	sdPackArg(argument, blockaddr);
	
	// we use mutiple sector reading ...
	sdmWriteCmd( CMD18,  argument);

}

void PostTrans()
{

	unsigned char argument[4];
	u8 tmp;
	
	// send stop command
	// clear argument buffer 
	sdPackArg(argument, 0);
	
	// we use mutiple sector reading ...
	// response type = R1B in spec NOTE!!!
	sdmWriteCmd( CMD12,  argument);

	if (sdmWaitStartBit() == 0 )
	{
			tmp = sdmRead(47);

	}

	// send more clocks
	sdDelay(2);   // 8 clocks 

}

/*
void TransData(u32 secNum, u8 *pBuffer)
{
	u32 j;

	for (j = 0; j < secNum; j++)
	{

		sdmFastReadData512((u16 *)pBuffer);
		pBuffer += SD_BLOCKSIZE;

	}
}



unsigned char sdmReadSectorsTT(unsigned long sector,unsigned char secNum, unsigned char *pBuffer)
{
	PreTrans(sector << SD_BLOCKSIZE_NBITS);
	TransData(secNum, (u8 *)pBuffer);
	PostTrans();

	return SD_SUCCESS;


}

*/

unsigned char sdmReadSectors(unsigned long sector,unsigned char secNum, unsigned char *pBuffer)
{
  

	// multi sector reading ...
	u32 j;
	

	u32 blockaddr;
	blockaddr = sector;
	/* Adjust the block address to a linear address */
	blockaddr <<= SD_BLOCKSIZE_NBITS;
	

	/* Pack the address */
	sdPackArg(argument, blockaddr);
	
	// we use mutiple sector reading ...
	sdmWriteCmd( CMD18,  argument);


	for (j = 0; j < secNum; j++)
	{

		sdmFastReadData512((u16 *)pBuffer);			// imp
		pBuffer += SD_BLOCKSIZE;

	}

	// send stop command
	/* clear argument buffer */
	sdPackArg(argument, 0);
	
	// we use mutiple sector reading ...
	// response type = R1B in spec NOTE!!!
	sdmSendCommand( CMD12, R1, response, argument);

	return SD_SUCCESS;


}

unsigned char sdmReadSectorCached(unsigned long sector,	// LBA
								 unsigned char *pBuffer,
								 unsigned long *SectorInCache //actual sector
								 )
{
  	// if the Sector is already in the memory buffer, we don't need to read the sector again
 	if(*SectorInCache==sector)
  		return 1;

	if(sdmReadBlock( sector, pBuffer)==SD_ERROR) 
             return 0;

	*SectorInCache=sector;

	return 1;
}

#define NEWSECT_WR_TEST

unsigned char sdmWriteSectors(unsigned long sector,unsigned char numSecs, unsigned char *buffer)
{
#ifdef NEWSECT_WR_TEST
	
	
	// todo 
	int maxSectors,curSector;
	u16 crc16[5];
	maxSectors = (numSecs == 0 ? 256 : numSecs);

	u32 blockaddr = sector * BYTE_PER_READ;


	// Pack the address 
	sdPackArg(argument, blockaddr);

	// write multi block
	sdmSendCommand( CMD25, CMD25_R, response, argument);
	sdmRead(16);

	u8 *p;
	
	p = (u8*)buffer;

	for (curSector=0; curSector<maxSectors; curSector++)
	{
		sdCRC16X( p, BYTE_PER_READ, (u8*)crc16);
		sdmWriteData( p, (u8*)crc16);
		
		p += BYTE_PER_READ;
	}



	// program busy
	u16 t = 0;
	do {
		t = *(vu16 *)(__ADDR_SD_DATA);
		t &= 1;
		
	} while (t == 0);   //check busy bit, t=1 break




	// Pack the address 
	sdPackArg(argument, 0);
	// write multi block
	sdmSendCommand( CMD12, R1, response, argument);

	sdmRead(16);
	// card is programming ...
	do {
		t = *(vu16 *)(__ADDR_SD_DATA);
		t &= 1;
		
	} while (t == 0);   //check busy bit, t=1 break

	return true;

//////////////////////////////////////////////////////////////////////////////
#else
	u8 *p = (u8*)buffer;

	if (numSecs == 0)
		numSecs = MAXTRANS_SECTORS;
	while (numSecs--)
	{
		if (sdmWriteBlock( sector, p) == SD_ERROR)
			return false;
		sector++;
		p += SD_BLOCKSIZE;
	}


	return true;

#endif
}

unsigned char sdmWriteSector(unsigned long sector,unsigned char *pBuffer)
{
	if(sdmWriteBlock(sector,pBuffer)==SD_ERROR) return 0;
	return 1;  
}

