
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <NDS.h>

#include "_console.h"
#include "_const.h"
#include "memtool.h"

#include "lang.h"

static ELang EL;

void SetLang(const ELang _EL)
{
  EL=_EL;
}

extern ELang GetLang(void)
{
  return(EL);
}

void Lang_GetUniStr(const char *estr,const char *jstr,UnicodeChar *unistr)
{
  if(unistr==NULL){
    _consolePrintf("Fatal error!! Lang_GetUniStr write to NULL\n");
    while(1);
  }
  
  const char *pstr=NULL;
  
  switch(EL){
    case EL_ENG: pstr=estr; break;
    case EL_JPN: pstr=jstr; break;
  }
  
  if(pstr==NULL){
    unistr[0]=(UnicodeChar)0;
    return;
  }
  
  StrConvert_Local2Unicode(pstr,unistr);
}

