
static int LastSaveType;

static TBitmap *pSubBGBM,*pIconDSCard,*pIconGBACart;
static TBitmap *pIconVectorR,*pIconVectorL;
static TBitmap *pIconWarning;
static TBitmap *pPrgNega,*pPrgPosi;

void InitDSCard(void)
{
  LastSaveType=-2;
  
  pSubBGBM=Bitmap_LoadFromFile("/ReinMoon/skin/subbg.bmp",true);
  pIconDSCard=Bitmap_LoadFromFile("/ReinMoon/skin/icon_dscard.bmp",true);
  pIconGBACart=Bitmap_LoadFromFile("/ReinMoon/skin/icon_gbacart.bmp",true);
  pIconVectorR=Bitmap_LoadFromFile("/ReinMoon/skin/icon_vectorr.bmp",true);
  pIconVectorL=Bitmap_LoadFromFile("/ReinMoon/skin/icon_vectorl.bmp",true);
  pIconWarning=Bitmap_LoadFromFile("/ReinMoon/skin/icon_warning.bmp",true);
  pPrgNega=Bitmap_LoadFromFile("/ReinMoon/skin/prgnega.bmp",true);
  pPrgPosi=Bitmap_LoadFromFile("/ReinMoon/skin/prgposi.bmp",true);
}

void PoolDSCard(void)
{
  int SaveType=cardmeGetType();
  
  const u32 BaseX=10,BaseY=24;
  
  bool reqref=false;
  
  if(LastSaveType!=SaveType) reqref=true;
  LastSaveType=SaveType;
  
  if(reqref==false) return;
  
  TGameData *pgd;
  
  {
    u32 DetectSaveSize=GetDetectSaveSize();
    u8 *pSaveData=(u8*)safemalloc(DetectSaveSize);
    cardmeReadEeprom(0,pSaveData,DetectSaveSize,SaveType);
    pgd=GetGameDataFromSaveData((char*)pSaveData,DetectSaveSize);
    if(pgd==NULL) pgd=&GameDataDummy;
    safefree(pSaveData); pSaveData=NULL;
  }
  
  CglCanvas *pCanvas=pScreenSub->pCanvas;
  
  {
    u16 *psrcbm=pSubBGBM->pBM;
    u16 *pdstbm=pCanvas->GetVRAMBuf();
    
    u32 ofs=((BaseY-21)*256)+(BaseX-6);
    psrcbm+=ofs;
    pdstbm+=ofs;
    
    for(u32 y=0;y<83;y++){
      MemCopy16DMA3(psrcbm,pdstbm,(ScreenWidth-(BaseX-6))*2);
      psrcbm+=256;
      pdstbm+=256;
    }
    for(u32 y=0;y<28;y++){
      MemCopy16DMA3(psrcbm,pdstbm,40*2);
      psrcbm+=256;
      pdstbm+=256;
    }
    
    pCanvas->SetFontBGColor(RGB15(31,31,31)|BIT15);
    pCanvas->SetFontTextColor(RGB15(0,0,0)|BIT15);
    
    pCanvas->TextOutA(BaseX+14,BaseY-18,"DS CARD");
    
    Bitmap_Draw(pIconDSCard,pCanvas,BaseX+1,BaseY+8);
  }
  
  {
    u16 *pBM=(u16*)safemalloc(32*32*2);
    if(LoadIconBM(EFT_File,pgd->ID,pBM)==true){
      u16 *pdst=pCanvas->GetVRAMBuf();
      u32 width=pCanvas->GetWidth();
      
      pdst+=((BaseY+40)*width)+(BaseX+1);
      
      DrawIcon(pBM,pdst,width);
    }
    safefree(pBM); pBM=NULL;
  }
  
  pCanvas->SetFontBGColor(RGB15(31,31,31)|BIT15);
  pCanvas->SetFontTextColor(RGB15(0,0,0)|BIT15);
  
  u32 left=BaseX+36;
  u32 top=BaseY+4;
  
  if(SaveType<=0){
    UnicodeChar msg[256];
    Lang_GetUniStr("Unknown save type or","Ή̃Z[u^CvA",msg);
    pCanvas->TextOutW(left+0,top+(1*14),msg);
    Lang_GetUniStr("DS card ejected.","DSJ[hĂ܂B",msg);
    pCanvas->TextOutW(left+0,top+(2*14),msg);
    }else{
    
    u32 SaveSize=cardmeSize(SaveType);
    
    char str[256];
    
    {
      char sizestr[256];
      sizestr[0]=(char)0;
      
      u32 SaveSizeBit=SaveSize*8;
      if(SaveSizeBit<1024){
        snprintf(sizestr,256,"%dbit",SaveSizeBit);
        }else{
        if(SaveSizeBit<1024*1024){
          snprintf(sizestr,256,"%dkbit",SaveSizeBit/1024);
          }else{
          snprintf(sizestr,256,"%dMbit",SaveSizeBit/1024/1024);
        }
      }
      
      char size2str[256];
      size2str[0]=(char)0;
      
      if(SaveSize<1024){
        snprintf(size2str,256,"%dbyte",SaveSize);
        }else{
        if(SaveSize<1024*1024){
          snprintf(size2str,256,"%dkbyte",SaveSize/1024);
          }else{
          snprintf(size2str,256,"%dMbyte",SaveSize/1024/1024);
        }
      }
      snprintf(str,256,"Type:%d %s (%s)",SaveType,sizestr,size2str);
      pCanvas->TextOutA(left,top,str);
    }
    
    top+=13+2;
    
    pCanvas->TextOutA(left,top+(0*13),"ID:");
    pCanvas->TextOutA(left+32,top+(0*13),pgd->ID);
    
    pCanvas->TextOutA(left,top+(1*13),"JPN:");
    pCanvas->TextOutW(left+32,top+(1*13),pgd->JPNName);
    
    pCanvas->TextOutA(left,top+(2*13),"ENG:");
    pCanvas->TextOutA(left+32,top+(2*13),pgd->ENGName);
    
  }
}

