
static char curpath[MAX_FILENAME_LENGTH];

static int TopIndex;
static int CurIndex;

#define ViewCount (6)

static void FileList_Init(void)
{
  FilesCount=0;
  pFiles=NULL;
  curpath[0]='/';
  curpath[1]=(char)0;
  
  TopIndex=0;
  CurIndex=0;
  
  TGameData *pgd=&GameDataDummy;
  
  if(pgd->JPNName==NULL){
    pgd->JPNName=(UnicodeChar*)safemalloc((3+1)*2);
    StrConvert_Local2Unicode("o^",pgd->JPNName);
  }
  if(pgd->Data==NULL){
    pgd->Data=(u8*)safemalloc(1);
    pgd->Data[0]=0;
  }
}

static void FileList_Free(void)
{
  if(pFiles==NULL) return;
  
  for(int idx=0;idx<FilesCount;idx++){
    TFile *pFile=&pFiles[idx];
    if(pFile->IconBM!=NULL){
      safefree(pFile->IconBM); pFile->IconBM=NULL;
    }
  }
  
  safefree(pFiles); pFiles=NULL;
  
  FilesCount=0;
}

static bool isSaveFilename(char *fn)
{
  while(*fn!=(char)0) fn++;
  fn-=4;
  
  if(fn[0]!='.') return(false);
  
  bool scf=true,m3f=true;
  
  if((fn[1]!='s')&&(fn[1]!='S')) scf=false;
  if((fn[2]!='a')&&(fn[2]!='A')) scf=false;
  if((fn[3]!='v')&&(fn[3]!='V')) scf=false;
  if(scf==true) return(true);
  
  if((fn[1]!='d')&&(fn[1]!='D')) m3f=false;
  if((fn[2]!='a')&&(fn[2]!='A')) m3f=false;
  if((fn[3]!='t')&&(fn[3]!='T')) m3f=false;
  if(m3f==true) return(true);
  
  return(false);
}

inline static bool isSwapFile(TFile *pf0,TFile *pf1)
{
  char *puc0=&pf0->lfn[0];
  char *puc1=&pf1->lfn[0];
  
  while(1){
    u32 uc0=*puc0;
    u32 uc1=*puc1;
    if(((u32)'A'<=uc0)&&(uc0<=(u32)'Z')) uc0+=0x20;
    if(((u32)'A'<=uc1)&&(uc1<=(u32)'Z')) uc1+=0x20;
    
    if(uc0==uc1){
      // t@C͂Ȃ͂
      if((uc0==0)&&(uc1==0)) return(false);
      }else{
      // t@C`FbN
      if(uc0==0) return(false);
      if(uc1==0) return(true);
      // r
      if(uc0<uc1) return(false);
      if(uc0>uc1) return(true);
    }
    
    puc0++; puc1++;
  }
  return(false);
}

static void FileList_Sort(void)
{
  if(FilesCount<2) return;
  
  u32 *topdata=(u32*)safemalloc(FilesCount*4);
  
  for(int idx=0;idx<FilesCount;idx++){
    u32 uc0=(u32)pFiles[idx].lfn[0];
    u32 uc1=(u32)pFiles[idx].lfn[1];
    if(((u32)'A'<=uc0)&&(uc0<=(u32)'Z')) uc0+=0x20;
    if(((u32)'A'<=uc1)&&(uc1<=(u32)'Z')) uc1+=0x20;
    topdata[idx]=(uc0<<16) | uc1;
  }
  
  for(int idx0=0;idx0<FilesCount-1;idx0++){
    for(int idx1=idx0+1;idx1<FilesCount;idx1++){
      TFile *pf0=&pFiles[idx0];
      TFile *pf1=&pFiles[idx1];
      bool SwapFlag=false;
      
      if(pf0->EFT!=pf1->EFT){
        if(pf0->EFT==EFT_File) SwapFlag=true;
        }else{
        if(topdata[idx0]>=topdata[idx1]){
          if(isSwapFile(pf0,pf1)==true) SwapFlag=true;
        }
      }
      
      if(SwapFlag==true){
        TFile ftemp=*pf0;
        *pf0=*pf1;
        *pf1=ftemp;
        
        u32 tmp=topdata[idx0];
        topdata[idx0]=topdata[idx1];
        topdata[idx1]=tmp;
      }
    }
  }
  
  safefree(topdata); topdata=NULL;
}

static void FileList_Refresh(void)
{
  FileList_Free();
  
  FAT_chdir(curpath);
  
  if(strcmp(curpath,"/")!=0) FilesCount++;
  
  {
    char lfn[MAX_FILENAME_LENGTH];
    u32 FAT_FileType=FAT_FindFirstFileLFN(lfn);
    
    while(FAT_FileType!=FT_NONE){
      switch(FAT_FileType){
        case FT_DIR: {
          if((strcmp(lfn,".")!=0)&&(strcmp(lfn,"..")!=0)) FilesCount++;
        } break;
        case FT_FILE: {
          if(isSaveFilename(lfn)==true) FilesCount++;
        } break;
      }
      FAT_FileType=FAT_FindNextFileLFN(lfn);
    }
  }
  
  pFiles=(TFile*)safemalloc(FilesCount*sizeof(TFile));
  if(pFiles==NULL){
    FilesCount=1;
    pFiles=(TFile*)safemalloc(FilesCount*sizeof(TFile));
  }
  
  for(int idx=0;idx<FilesCount;idx++){
    TFile *pFile=&pFiles[idx];
    pFile->lfn[0]=(char)0;
    pFile->EFT=EFT_None;
    pFile->FileSize=0;
    pFile->pGameData=&GameDataDummy;
    pFile->IconBM=NULL;
  }
  
  int idx=0;
  
  if(strcmp(curpath,"/")!=0){
    TFile *pFile=&pFiles[idx];
    strcpy(pFile->lfn,curpath);
    pFile->EFT=EFT_Back;
    idx++;
  }
  
  bool fileexists=false;
  
  {
    char lfn[MAX_FILENAME_LENGTH];
    u32 FAT_FileType=FAT_FindFirstFileLFN(lfn);
    
    while(FAT_FileType!=FT_NONE){
      if(idx==FilesCount) break;
      
      switch(FAT_FileType){
        case FT_DIR: {
          if((strcmp(lfn,".")!=0)&&(strcmp(lfn,"..")!=0)){
            TFile *pFile=&pFiles[idx];
            strcpy(pFile->lfn,lfn);
            strcat(pFile->lfn,"/");
            pFile->EFT=EFT_Path;
            idx++;
          }
        } break;
        case FT_FILE: {
          if(isSaveFilename(lfn)==true){
            fileexists=true;
            TFile *pFile=&pFiles[idx];
            strcpy(pFile->lfn,lfn);
            pFile->EFT=EFT_File;
            idx++;
          }
        } break;
      }
      
      FAT_FileType=FAT_FindNextFileLFN(lfn);
    }
  }
  
  if(fileexists==true) ProgressWindow_Open("load save data...","Z[uf[^ǂݍݒc");
  
  for(int idx=0;idx<FilesCount;idx++){
    if(fileexists==true) ProgressWindow_SetPos(idx,FilesCount);
    TFile *pFile=&pFiles[idx];
    if(pFile->EFT==EFT_File){
      FAT_FILE *fp=FAT_fopen(pFile->lfn,"r");
      
      FAT_fseek(fp,0,SEEK_END);
      pFile->FileSize=FAT_ftell(fp);
      FAT_fseek(fp,0,SEEK_SET);
      
      u32 DetectSaveSize=GetDetectSaveSize();
      u8 *buf=(u8*)safemalloc(DetectSaveSize);
      FAT_fread(buf,1,DetectSaveSize, fp);
      TGameData *pgd=GetGameDataFromSaveData((char*)buf,DetectSaveSize);
      if(pgd!=NULL) pFile->pGameData=pgd;
      safefree(buf); buf=NULL;
      
      FAT_fclose(fp);
    }
  }
  
  if(fileexists==true) ProgressWindow_Close();
  
  FileList_Sort();
}

static void FileList_DrawMain(CglCanvas *pCanvas)
{
  int Count=ViewCount;
  
  if(FilesCount<(TopIndex+Count)) Count=FilesCount-TopIndex;
  
  {
    u16 *pdst=pScreenMain->pCanvas->GetVRAMBuf();
    u32 width=pScreenMain->pCanvas->GetWidth();
    u32 height=pScreenMain->pCanvas->GetHeight();
    MemSet16DMA3(RGB15(0,0,1)|BIT15,&pdst[0],height*width*2);
  }
  
  for(int idx=0;idx<Count;idx++){
    int left=2;
    int top=idx*32;
    
    u16 bgcol,textcol;
    
    if((TopIndex+idx)==CurIndex){
      bgcol=RGB15(28,28,31)|BIT15;
      textcol=RGB15(0,0,0)|BIT15;
      }else{
      bgcol=RGB15(0,0,1)|BIT15;
      textcol=RGB15(28,28,31)|BIT15;
    }
    
    {
      u16 *pdst=pScreenMain->pCanvas->GetVRAMBuf();
      u32 width=pScreenMain->pCanvas->GetWidth();
      MemSet16DMA3(bgcol,&pdst[top*width],31*width*2);
      MemSet16DMA3(RGB15(0,0,8)|BIT15,&pdst[(top+31)*width],1*width*2);
    }
    pCanvas->SetFontBGColor(bgcol);
    pCanvas->SetFontTextColor(textcol);
    
    TFile *pFile=&pFiles[TopIndex+idx];
    char buf[256];
    
    snprintf(buf,256,"%s",pFile->lfn);
    pCanvas->TextOutL(left+34,top+2+0,buf);
    
    if(pFile->EFT==EFT_File){
//      snprintf(buf,256,"%s %s",pFile->pGameData->ID,pFile->pGameData->ENGName);
//      pCanvas->TextOutL(left+34,top+2+12+2,buf);
      {
        buf[0]=(char)0;
        u32 SaveSize=pFile->FileSize;
        if(SaveSize<1024){
          snprintf(buf,256,"%dbyte ",SaveSize);
          }else{
          if(SaveSize<1024*1024){
            snprintf(buf,256,"%dkbyte ",SaveSize/1024);
            }else{
            snprintf(buf,256,"%dMbyte ",SaveSize/1024/1024);
          }
        }
        
        strcat(buf,pFile->pGameData->ID);
        strcat(buf," ");
        
        UnicodeChar us[1024];
        StrConvert_Ank2Unicode(buf,us);
        
        if(GetLang()!=EL_JPN){
          UnicodeChar ustmp[1024];
          StrConvert_Ank2Unicode(pFile->pGameData->ENGName,ustmp);
          Unicode_Add(us,ustmp);
          }else{
          Unicode_Add(us,pFile->pGameData->JPNName);
        }
        
        pCanvas->TextOutW(left+34,top+2+12+2,us);
      }
    }
    
    if(pFile->IconBM==NULL){
      pFile->IconBM=(u16*)safemalloc(32*32*2);
      if(LoadIconBM(pFile->EFT,pFile->pGameData->ID,pFile->IconBM)==false){
        safefree(pFile->IconBM); pFile->IconBM=NULL;
      }
    }
    
    if(pFile->IconBM!=NULL){
      u16 *pdst=pCanvas->GetVRAMBuf();
      u32 width=pCanvas->GetWidth();
      
      pdst+=(top*width)+left;
      
      DrawIcon(pFile->IconBM,pdst,width);
    }
  }
  
}

static void FileList_DrawSub(CglCanvas *pCanvas)
{
  TFile *pFile=&pFiles[CurIndex];
  TGameData *pgd=pFile->pGameData;
  
  const u32 BaseX=50,BaseY=107;
  
  {
    u16 *psrcbm=pSubBGBM->pBM;
    u16 *pdstbm=pCanvas->GetVRAMBuf();
    
    u32 ofs=((BaseY-21)*256)+(BaseX-6);
    psrcbm+=ofs;
    pdstbm+=ofs;
    
    for(u32 y=0;y<97;y++){
      MemCopy16DMA3(psrcbm,pdstbm,(ScreenWidth-(BaseX-6))*2);
      psrcbm+=256;
      pdstbm+=256;
    }
    
    pCanvas->SetFontBGColor(RGB15(31,31,31)|BIT15);
    pCanvas->SetFontTextColor(RGB15(0,0,0)|BIT15);
    
    pCanvas->TextOutA(BaseX+14,BaseY-18,DIMediaName);
    
    if(false){
      pCanvas->TextOutA(BaseX+14,BaseY-18,"Movie Player CF");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"M3 perfect CF");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"M3 perfect SD");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"SuperCard CF");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"SuperCard SD");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"GBA Flash Cart");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"EZ-Flash 4 MiniSD");
      pCanvas->TextOutA(BaseX+14,BaseY-18,"Max Media CF");
    }
    
    Bitmap_Draw(pIconGBACart,pCanvas,BaseX+1,BaseY+4);
  }
  
  if(pFile->IconBM!=NULL){
    u16 *pdst=pCanvas->GetVRAMBuf();
    u32 width=pCanvas->GetWidth();
    
    pdst+=((BaseY+36)*width)+(BaseX+1);
    
    DrawIcon(pFile->IconBM,pdst,width);
  }
  
  pCanvas->SetFontBGColor(RGB15(31,31,31)|BIT15);
  pCanvas->SetFontTextColor(RGB15(0,0,0)|BIT15);
  
  u32 left=BaseX+36;
  u32 top=BaseY+2;
  
  if(pFile->EFT!=EFT_File){
    }else{
    
    char str[256];
    
    pCanvas->TextOutA(left,top+(0*13),pFile->lfn);
    
    char size2str[256];
    size2str[0]=(char)0;
    u32 SaveSize=pFile->FileSize;
    
    if(SaveSize<1024){
      snprintf(size2str,256,"%dbyte",SaveSize);
      }else{
      if(SaveSize<1024*1024){
        snprintf(size2str,256,"%dkbyte",SaveSize/1024);
        }else{
        snprintf(size2str,256,"%dMbyte",SaveSize/1024/1024);
      }
    }
    snprintf(str,256,"FileSize: %s",size2str);
    pCanvas->TextOutA(left,top+(1*13),str);
    
    top+=(2*13)+2;
    
    pCanvas->TextOutA(left,top+(0*13),"ID:");
    pCanvas->TextOutA(left+32,top+(0*13),pgd->ID);
    
    pCanvas->TextOutA(left,top+(1*13),"JPN:");
    pCanvas->TextOutW(left+32,top+(1*13),pgd->JPNName);
    
    pCanvas->TextOutA(left,top+(2*13),"ENG:");
    pCanvas->TextOutA(left+32,top+(2*13),pgd->ENGName);
    
  }
}

static void FileList_DrawCanvas(bool WithSub)
{
  FileList_DrawMain(pScreenMain->pCanvas);
  pScreenMain->Flip(true);
  
  if(WithSub==true) FileList_DrawSub(pScreenSub->pCanvas);
}

void FileList_SetCursor(int idx)
{
  if(idx<0) idx=0;
  if(FilesCount<=idx) idx=FilesCount-1;
  
  CurIndex=idx;
  
  if((TopIndex+ViewCount)<=CurIndex) TopIndex=CurIndex+1-ViewCount;
  if(TopIndex<0) TopIndex=0;
  if(CurIndex<TopIndex) TopIndex=CurIndex;
}


void FileList_MoveCursor(int vector)
{
  FileList_SetCursor(CurIndex+vector);
}

static void ChangePath_Back(char *lastpath)
{
  int pos1=-1,pos2=-1;
  int idx=0;
  
  while(curpath[idx]!=(char)0){
    if(curpath[idx]=='/'){
      pos2=pos1;
      pos1=idx;
    }
    idx++;
  }
  
  if(pos2==-1){
    lastpath[0]=(char)0;
    strcpy(curpath,"/");
    return;
  }
  
  strcpy(lastpath,&curpath[pos2+1]);
  curpath[pos2+1]=(char)0;
}

static void ChangePath_Into(char *lfn)
{
  strcat(curpath,lfn);
}

void FileList_Execute_Execute_B(void)
{
  Sound_Start(ESND_Execute);
  
  char lastpath[MAX_FILENAME_LENGTH];
  
  ChangePath_Back(lastpath);
  
  TopIndex=0;
  CurIndex=0;
  
  FileList_Refresh();
  
  for(int idx=0;idx<FilesCount;idx++){
    TFile *pFile=&pFiles[idx];
    if(strcmp(pFile->lfn,lastpath)==0){
      FileList_SetCursor(idx);
      break;
    }
  }
  
  FileList_DrawCanvas(true);
}

void FileList_Execute_Execute_A(void)
{
  TFile *pFile=&pFiles[CurIndex];
  EFileType EFT=pFile->EFT;
  
  switch(EFT){
    case EFT_None: return; break;
    case EFT_Back: FileList_Execute_Execute_B(); return; break;
    case EFT_Path: {
      Sound_Start(ESND_Execute);
      ChangePath_Into(pFile->lfn);
      
      TopIndex=0;
      CurIndex=0;
      
      FileList_Refresh();
      FileList_DrawCanvas(true);
    } break;
    case EFT_File: {
      Execute_CurrentFile(pFile);
      
      FileList_Refresh();
      FileList_DrawCanvas(true);
      
      LastSaveType=-2; // request DS card information refresh.
    } break;
    default: return; break;
  }
}

