/*---------------------------------------------------------------------------------
	$Id: ipc.h,v 1.13 2006/01/17 09:47:00 wntrmute Exp $

	Inter Processor Communication

	Copyright (C) 2005
		Michael Noland (joat)
		Jason Rogers (dovoto)
		Dave Murphy (WinterMute)

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any
	damages arising from the use of this software.

	Permission is granted to anyone to use this software for any
	purpose, including commercial applications, and to alter it and
	redistribute it freely, subject to the following restrictions:

	1.	The origin of this software must not be misrepresented; you
		must not claim that you wrote the original software. If you use
		this software in a product, an acknowledgment in the product
		documentation would be appreciated but is not required.
	2.	Altered source versions must be plainly marked as such, and
		must not be misrepresented as being the original software.
	3.	This notice may not be removed or altered from any source
		distribution.

	$Log: ipc.h,v $
	Revision 1.13  2006/01/17 09:47:00  wntrmute
	*** empty log message ***
	
	Revision 1.12  2005/09/20 04:59:04  wntrmute
	replaced defines with enums
	replaced macros with static inlines
	
	Revision 1.11  2005/08/23 17:06:10  wntrmute
	converted all endings to unix

	Revision 1.10  2005/08/03 05:26:42  wntrmute
	use BIT macro
	corrected header include

	Revision 1.9  2005/07/27 02:20:05  wntrmute
	resynchronise with ndslib
	Updated GL with float wrappers for NeHe


---------------------------------------------------------------------------------*/

#ifndef NDS_IPC6_INCLUDE
#define NDS_IPC6_INCLUDE


#include <nds/jtypes.h>

//---------------------------------------------------------------------------------

enum EIPCSND {EIPCSND_Null=0,EIPCSND_AllStop=1,EIPCSND_Play=2,EIPCSND_PlayLoop=3};

//---------------------------------------------------------------------------------
typedef struct sTransferRegion6 {
//---------------------------------------------------------------------------------
  uint32 heartbeat;          // counts frames
  uint32 UserLanguage;       // from BIOS

	int16 touchX,   touchY;   // TSC X, Y
	int16 touchXpx, touchYpx; // TSC X, Y pixel values
	int16 touchZ1,  touchZ2;  // TSC x-panel measurements
	uint16 tdiode1,  tdiode2;  // TSC temperature diodes
	uint32 temperature;        // TSC computed temperature

	uint16 buttons;            // X, Y, /PENIRQ buttons

	union {
		uint8 curtime[8];        // current time response from RTC

    struct {
			u8 rtc_command;
			u8 rtc_year;           //add 2000 to get 4 digit year
			u8 rtc_month;          //1 to 12
			u8 rtc_day;            //1 to (days in month)

			u8 rtc_incr;
			u8 rtc_hours;          //0 to 11 for AM, 52 to 63 for PM
			u8 rtc_minutes;        //0 to 59
			u8 rtc_seconds;        //0 to 59
    };
  };

	uint16 battery;            // battery life ??  hopefully.  :)
	uint16 aux;                // i have no idea...

  volatile EIPCSND IPCSND;
  vu32 IPCSND_Freq;
  vu32 IPCSND_BufCount;
  volatile s16 *IPCSND_lbuf,*IPCSND_rbuf;
} TransferRegion6, * pTransferRegion6;


#define IPC6 ((TransferRegion6 volatile *)(0x027FF000))

#endif

//////////////////////////////////////////////////////////////////////

